#ifndef AFFICHABLE_H
#define AFFICHABLE_H

#include "Dimension.h"
#include <iosfwd>
using std::ostream;

template <class T>
   struct Affichable
   {
      virtual ostream & projeter
         (ostream &, const Dimension<T> &) const = 0;
   protected:
      virtual ~Affichable () throw()
         { }
   };

#endif