#include "Afficheur.h"
#include "Autonome.h"
#include "VueEspace.h"
#include "Affichable.h"
#include "SingletonsOrdonnes.h"
#include "GenerateurStochastique.h"
#include "Singletons.h"
#include "ServicesSysteme.h"
#include "Catalogues.h"
#include "Partie.h"
#include "TresorsSublimes.h"
// parties tudiantes
#include "PartieEtudiante.h"
#include <iostream>
using std::cout;
#include <sstream>
using std::ostringstream;


class Afficheur::Impl
   : public Autonome
{
   typedef position_traits::coord_t coord_t;
   friend class Afficheur;
   Affichable<coord_t> *source_;
public:
   Impl ()
      : Autonome (delai_t(RythmeAffichage ())), source_ (0)
   {
   }
   void SetSource (Affichable<coord_t> *p)
      { source_ = p; }
   void Agir ()
   {
      typedef VueEspace<coord_t> vue_type;
      //
      // Code de gnration de la carte
      //
      Affichable<coord_t> *p = source_;
      if (p)
      {
         ostringstream oss;
         p->projeter (oss, ObtenirSingleton<vue_type>().ZoneJeu ().dimension());
         ObtenirSingleton<vue_type>().ZoneJeu () << oss.str ();
      }
      //
      // Code d'affichage de la fentre
      //
      system ("cls");
      cout << ObtenirSingleton<vue_type>().ZoneJeu ()
           << ObtenirSingleton<vue_type>().ZoneMessages ();
   }
};

Afficheur::Impl *Afficheur::Creer ()
{
   Afficheur::Impl *p = new Afficheur::Impl;
   p->Demarrer ();
   return p;
}
void Afficheur::Liberer (const Afficheur::Impl *p) throw()
   { delete p; }

void Afficheur::SetSource (Affichable<coord_t> *p)
   { pimpl_->SetSource (p); }
