#ifndef DIRECTION_H
#define DIRECTION_H

#include <string>
using std::string;

//
// Le type Direction reprsente une direction (au
// sens des points cardinaux)
//
enum Direction
{
   Est, Nord, Ouest, Sud, NB_DIRECTIONS
};

//
// Fonction ObtenirNomDeDirection()
// - intrants:
//    - la direction pour laquelle on souhaite obtenir
//      un nom lisible pour des humain(e)s
// - extrants:
//     - un nom lisible pour des humain(e)s pour la
//       direction supple
// - rle:
//    - permet d'obtenir un nom lisible en fonction d'une
//      direction, probablement pour fins d'affichage
//
string ObtenirNomDeDirection(const Direction dir);

#endif
