#include "Partie.h"
#include <iostream>
using std::clog;

void Partie::DemarrerJournal ()
   { clog.rdbuf (journal_.rdbuf ()); }
void Partie::TerminerJournal ()
   { clog.rdbuf (0); }

const string & Partie::DiagnosticFin () const throw()
{
   //
   // Garder en synchro avec les codes dans le .h
   //
   static const string MESSAGE [] =
   {
      "erreur lors de l'initialisation",
      "erreur lors de l'excution",
      "tat inconnu",
      "trsor pris par l'avatar",
      "avatar dvor par un monstre"
   };
   return MESSAGE[resultat_ >= RESULTAT_MIN && resultat_ <= RESULTAT_MAX?
                  resultat_ : INCONNU];
}
