#include "PartieEtudiante.h"
#include <iostream>
using std::ostream;
#include <string>
using std::string;
#include <cmath>
using std::abs;

//
// Fonction ControlerAvatar()
// - Intrants:
//    - nom, le nom de l'avatar (une string);
//    - avant, l'tat de l'avatar au moment o la fonction aura
//      t appele (l'tat avant que votre code n'ait pris une
//      dcision);
//    - memoire, un tableau de MemoireAvatar indiquant la totalit
//      des moments de jeu pour lui jusqu'au moment de l'appel de
//      la fonction; et
//    - nbElemsMemoire, la taille (exprime en nombre d'lments)
//      du tableau Memoire ci-dessus.
// - Extrants:
//    - flux, un flux (que vous pouvez utilisez exactement comme vous
//      utilisez cout) sur lequel vous pourrez crire des messages.
//      Ces messages apparatront  l'cran dans une zone de messages
//      et seront crits sur disque dans un journal (fichier nomm
//      Journal.txt), ce qui vous permettra de dverminer votre oeuvre;
//      de mme que
//    - apres, l'tat de l'avatar tel que vous souhaitez qu'il soit suite
//       l'appel de la fonction (l'tat aprs que votre code ait pris
//      une dcision). Vous pouvez indiquer la direction souhaite pour
//      son regard et la position que vous souhaitez qu'il occupe. Ces
//      valeurs seront acceptes si elles ne sont pas illgales.
// - Rle:
//    - permet de contrler la destine d'un avatar.
//
// Note: si vous dbordez des tableaux, a va planter mchamment et ce
//       sera votre faute. Na na!
//
// Note: si vous faites une boucle infinie dans cette fonction, les autres
//       cratures du jeu continueront quant  elle de fonctionner, alors
//       soyez prudent(e)s!
//
// Note: cette fonction sera appele rgulirement pour permettre  un
//       avatar de prendre une dcision base sur ce qu'il sait, ce qu'il
//       voit et ce qu'il veut faire.  chaque appel, vous recevrez, par
//       le paramtre avant, l'tat o vous en tes prsentement, et
//       vous indiquerez par le paramtre apres l o vous souhaitez en
//       tre lors du prochain appel.
//
// Note: les valeurs que vous indiquerez dans le tableau Etats de Apres
//       seront copies dans le tableau Etats de Avant lors du prochain
//       appel, ce qui vous donnera une certaine latitude pour rflchir.
//
// Note: vous ne pouvez vous dplacer que d'une position  la fois, en X
//       ou en Y (mais pas les deux  la fois). Vous ne pouvez pas
//       traverser les murs. Il n'y a pas de contraintes sur les rotations
//       de la direction du regard. Si vous tentez de tricher, votre
//       mouvement sera refus et vous demeurerez sur place.
//
void ControlerAvatar
   (ostream &flux, const string &nom,
                   const DescripteurAvatar &avant,
                   DescripteurAvatar &apres,
                   const MemoireAvatar memoire[],
                   const int nbElemsMemoire)
{
}

//
// Fonction ControlerMonstre()
// - Intrants:
//    - nom, le nom du monstre (une string);
//    - avant, l'tat du monstre au moment o la fonction aura t
//      appele (l'tat avant que votre code n'ait pris une dcision);
//    - memoire, un tableau de MemoireMonstre indiquant les plus rcents
//      moments de jeu pour lui jusqu'au moment de l'appel de la fonction; et
//    - nbElemsMemoire, la taille (exprime en nombre d'lments) du tableau
//      Memoire ci-dessus (PRUDENCE: cette taille peut tre plus petite que
//      TAILLE_MEMOIRE_MONSTRE, surtout au dbut du jeu!).
// - Extrants:
//    - flux, un flux (que vous pouvez utilisez exactement comme vous
//      utilisez cout) sur lequel vous pourrez crire des messages.
//      Ces messages apparatront  l'cran dans une zone de messages
//      et seront crits sur disque dans un journal (fichier nomm
//      Journal.txt), ce qui vous permettra de dverminer votre oeuvre;
//      de mme que
//    - apres, l'tat du monstre tel que vous souhaitez qu'il soit suite
//       l'appel de la fonction (l'tat aprs que votre code ait pris
//      une dcision). Vous pouvez indiquer la direction souhaite pour
//      son regard et la position que vous souhaitez qu'il occupe. Ces
//      valeurs seront acceptes si elles ne sont pas illgales.
// - Rle:
//    - permet de contrler la destine d'un monstre. Sera appele pour
//      chaque monstre avec des tats avant/ apres distincts.
//
// Note: si vous dbordez des tableaux, a va planter mchamment et ce
//       sera votre faute. Na na!
//
// Note: si vous faites une boucle infinie dans cette fonction, les autres
//       cratures du jeu continueront quant  elle de fonctionner, alors
//       soyez prudent(e)s!
//
// Note: cette fonction sera appele rgulirement pour permettre  un
//       monstre de prendre une dcision base sur ce qu'il sait, ce qu'il
//       sent et ce qu'il veut faire.  chaque appel, vous recevrez, par
//       le paramtre avant, l'tat o vous en tes prsentement, et
//       vous indiquerez par le paramtre apres l o vous souhaitez en
//       tre lors du prochain appel.
//
// Note: les valeurs que vous indiquerez dans le tableau Etats de Apres
//       seront copies dans le tableau Etats de Avant lors du prochain
//       appel, ce qui vous donnera une certaine latitude pour rflchir.
//
// Note: vous ne pouvez vous dplacer que d'une position  la fois, en X
//       ou en Y (mais pas les deux  la fois). Vous ne pouvez pas
//       traverser les murs. Il n'y a pas de contraintes sur les rotations
//       de la direction du regard. Si vous tentez de tricher, votre
//       mouvement sera refus et vous demeurerez sur place.
//

void ControlerMonstre
   (ostream &flux, const string &nom,
                   const DescripteurMonstre &avant,
                   DescripteurMonstre &apres,
                   const MemoireMonstre memoire[],
                   const int nbElemsMemoire)
{
}