#ifndef SECTION_CRITIQUE_WIN32_H
#define SECTION_CRITIQUE_WIN32_H

#include "Incopiable.h"
#include "ISectionCritique.h"
#include <windows.h>

class SectionCritiqueWin32
   : Incopiable, public ISectionCritique
{
   CRITICAL_SECTION critsect_;
public:
   SectionCritiqueWin32 ()
      { InitializeCriticalSection (&critsect_); }
   ~SectionCritiqueWin32 () throw()
      { DeleteCriticalSection(&critsect_); }
   void Entrer () const volatile
      { EnterCriticalSection (const_cast<CRITICAL_SECTION*>(&critsect_)); }
   void Quitter () const volatile
      { LeaveCriticalSection (const_cast<CRITICAL_SECTION*>(&critsect_)); }
};

#endif
