#ifndef SINGLETON_WRAPPER_H
#define SINGLETON_WRAPPER_H

template <class T>
   struct SingletonWrapper
   {
      typedef T type_t;
   private:
      type_t singleton;
   public:
      SingletonWrapper() throw()
         { }
      ~SingletonWrapper() throw()
         { }
      type_t & Get() throw()
         { return singleton; }
   };

#endif
