#ifndef SINGLETONS_H
#define SINGLETONS_H

#include "type_list.h"
#include "Partie.h"
#include "PositionTraits.h"
#include "VueEspace.h"
#include "TresorsSublimes.h"
#include "Catalogues.h"
#include "TroupeHeroique.h"
#include "HordeMalefique.h"
#include "GenerateurStochastique.h"

typedef type_list <
   HordeMalefique, type_list <
      TroupeHeroique, type_list <
         TresorsSublimes, type_list <
            Catalogues, type_list <
               VueEspace<position_traits::coord_t>, type_list <
                  Partie, type_list <
                     GenerateurStochastique, Vide
                  >
               >
            >
         >
      >
   >
> ListeSingletons;

#include "SingletonsOrdonnes.h"

template <class T>
   T & ObtenirSingleton ()
      { return SingletonsOrdonnes<ListeSingletons>::Get().GetSingleton <T> (); }


#endif