#ifndef STOPPABLE_H
#define STOPPABLE_H
//
// IEvenement et Evenement sont des exercices de
// rdaction de code dans mes cours
//
#include "Evenement.h"

class Stoppable
{
   bool m_ArretDemande, m_ArretComplete;
   Evenement m_Evenement;
public:
   Stoppable ()
      : m_ArretComplete (false), m_ArretDemande (false),
        m_Evenement (Evenement::ReinitialisationAutomatique ())
   {
   }
   bool GetArretComplete () const volatile throw ()
      { return m_ArretComplete; }
   bool GetArretDemande () const volatile throw ()
      { return m_ArretDemande; }
   void DemandeArret () volatile throw ()
      { m_ArretDemande  = true; }
   void ArretComplet () volatile
   {
      m_ArretComplete = true;
      m_Evenement.Provoquer ();
   }
   bool AttendreArret () const volatile
      { return m_Evenement.Attendre (); }
   bool AttendreArret (const int Delai) const volatile
      { return m_Evenement.Attendre (Delai); }
   ~Stoppable () { }
};

#endif