#ifndef RELATION_H
#define RELATION_H

namespace relation
{
   template <class T>
      struct equivalence
      {
         friend bool operator!= (const T &a, const T &b)
            { return !(a == b); }
      };
   template <class T>
      struct ordre
      {
         friend bool operator<= (const T &a, const T &b)
            { return !(b < a); }
         friend bool operator> (const T &a, const T &b)
            { return b < a; }
         friend bool operator>= (const T &a, const T &b)
            { return !(a < b); }
      };
}

#endif

