#ifndef AFFICHEUR_H
#define AFFICHEUR_H

#include "PtrPartage.h"
#include "PositionTraits.h"
#include "Liberateur.h"
#include <string>
using std::string;

template <class>
   struct Affichable;

class Afficheur
{
   class Impl;
   static Impl *Creer ();
   static void Liberer (const Impl *) throw();
   friend struct Liberateur<Afficheur>;
   PtrPartage<Impl, Liberateur<Afficheur> > pimpl_;
public:
   typedef position_traits::coord_t coord_t;
   Afficheur ()
      : pimpl_ (Creer ())
   {
   }
   void SetSource (Affichable<coord_t> *);
};

#endif