#ifndef AUTONOME_H
#define AUTONOME_H

#include "Acteur.h"
#include "Rythmique.h"
#include "Stoppable.h"

class ThreadRep;

class Autonome
   : public Acteur, public Rythmique, public Stoppable
{
   ThreadRep *rep_;
protected:
   Autonome (const delai_t);
   bool Demarrer ();
   void Arreter () throw();
public:
   virtual void LorsDuDemarrage () {}
   virtual void AvantDeTerminer () {}
   virtual ~Autonome () throw ()
      { Arreter (); }
};

#endif