#ifndef DIMENSION_H
#define DIMENSION_H

template <class T>
   class Dimension
   {
   public:
      typedef T value_type;
   private:
      value_type largeur_,
                 hauteur_;
   public:
      Dimension (const value_type largeur, const value_type hauteur)
         : largeur_(largeur), hauteur_(hauteur)
      {
      }
      value_type largeur () const
         { return largeur_; }
      value_type hauteur () const
         { return hauteur_; }
   };

#endif
