#include "Direction.h"
#include "Incopiable.h"
#include <string>
using std::string;
//
// Singleton hors squence: aucune dpendance apparente avec les autres
//
class InitialiseurNomsDirections
   : Incopiable
{
   string noms_[NB_DIRECTIONS];
   static InitialiseurNomsDirections singleton;
   InitialiseurNomsDirections ()
   {
      noms_[Nord]  = "Nord";
      noms_[Sud]   = "Sud";
      noms_[Est]   = "Est";
      noms_[Ouest] = "Ouest";
   }
public:
   ~InitialiseurNomsDirections () throw()
      { }
   static const InitialiseurNomsDirections &Get ()
      { return singleton; }
   const string & NomDirection (const Direction dir) const throw()
   {
      static const string INVALIDE = "Invalide";
      return dir >= 0 && dir < NB_DIRECTIONS? noms_[dir] : INVALIDE;
   }
};

InitialiseurNomsDirections InitialiseurNomsDirections::singleton;

string ObtenirNomDeDirection (const Direction dir)
   { return InitialiseurNomsDirections::Get ().NomDirection (dir); }
