#include "GenerateurStochastique.h"
#include <ctime>
using std::time;
#include <cstdlib>
using std::rand;
using std::srand;

GenerateurStochastique::GenerateurStochastique ()
   { srand (static_cast<unsigned int>(time (0))); }

GenerateurStochastique::value_type
   GenerateurStochastique::Prochain () const throw ()
      { return rand (); }

#pragma warning (disable : 4290)
GenerateurStochastique::value_type
   GenerateurStochastique::Prochain
      (const value_type borneMin, const value_type borneMax) const throw (BornesInvalides)
{
   if (borneMax < borneMin) throw BornesInvalides();
   return Prochain () % (borneMax - borneMin + 1) + borneMin;
}
#pragma warning (default : 4290)
