#ifndef GENERATEURSTOCHASTIQUE_H
#define GENERATEURSTOCHASTIQUE_H

#include "Incopiable.h"
#include "SingletonWrapper.h"

#pragma warning (disable : 4290)

class GenerateurStochastique
   : Incopiable
{
   GenerateurStochastique ();
   friend struct SingletonWrapper<GenerateurStochastique>;
public:
   typedef int value_type;
   ~GenerateurStochastique() throw()
      { }
   value_type Prochain () const throw ();
   // inclusif
   class BornesInvalides {};
   value_type Prochain
      (const value_type borneMin, const value_type borneMax) const throw (BornesInvalides);
};

#pragma warning (default : 4290)

#endif