#ifndef POSITIONNABLE_H
#define POSITIONNABLE_H

#include "PositionTraits.h"

class Positionnable
{
public:
   typedef position_traits::point_t point_t;
   Positionnable (const point_t &pos = point_t ()) throw ()
      : pos_(pos)
   {
   }
   const point_t & position () const throw ()
      { return pos_; }
//protected:
   void positionner (const point_t &pos) throw ()
      { pos_ = pos; }
private:
   point_t pos_;
};

class MemePosition
{
public:
   typedef Positionnable::point_t point_t;
private:
   point_t pos_;
public:
   MemePosition (const point_t &pos)
      : pos_(pos)
   {
   }
   bool operator () (const Positionnable *p)
      { return p->position () == pos_; }
};

#endif 
