#include "ServicesSymboles.h"
#include "Catalogues.h"
#include "SingletonsOrdonnes.h"
#include "Singletons.h"
#include <locale>
using std::ctype;
using std::locale;
using std::use_facet;

const symbole_t SYMBOLE_MUR = use_facet<ctype<symbole_t> >(locale("")).widen ('#');

bool EstSymboleInconnu (const symbole_t Sym)
   { return Sym == SYMBOLE_INCONNU; }
bool EstSymboleAvatar (const symbole_t Sym)
   { return TrouverDansCatalogue (ObtenirSingleton<Catalogues>().catalogue<Avatar> (), Sym); }
bool EstSymboleMur (const symbole_t Sym)
   { return Sym == SYMBOLE_MUR; }
bool EstSymboleVide (const symbole_t Sym)
   { return Sym == SYMBOLE_VIDE; }
bool EstSymboleMonstre (const symbole_t Sym)
   { return TrouverDansCatalogue (ObtenirSingleton<Catalogues>().catalogue<Monstre> (), Sym); }
bool EstSymboleTresor (const symbole_t Sym)
   { return TrouverDansCatalogue (ObtenirSingleton<Catalogues>().catalogue<Tresor> (), Sym); }
