#ifndef SERVICESSYMBOLES_H
#define SERVICESSYMBOLES_H

//
// Un symbole_t reprsente un symbole affichable sur la carte
//
typedef char symbole_t;
const symbole_t SYMBOLE_INCONNU = '?';
const symbole_t SYMBOLE_VIDE = ' ';

//
// Prdicats fournis par les professeurs, permettant d'analyser
// un symbole donn. Par exemple, EstSymboleMur() permet de
// savoir si un symbole reprsente un mur.
//
bool EstSymboleInconnu (const symbole_t Sym);
bool EstSymboleAvatar (const symbole_t Sym);
bool EstSymboleMur (const symbole_t Sym);
bool EstSymboleVide (const symbole_t Sym);
bool EstSymboleMonstre (const symbole_t Sym);
bool EstSymboleTresor (const symbole_t Sym);

#endif
