#ifndef SERVICESSYSTEME_H
#define SERVICESSYSTEME_H

#include <string>

void DemarrerJournal ();
void TerminerJournal ();

class Journaliseur
{
public:
   Journaliseur ()
      { DemarrerJournal (); }
   ~Journaliseur ()
      { TerminerJournal (); }
};

void AttendreFinDePartie ();
void ProvoquerFinDePartie (int resultat);
bool TesterFinDePartie ();
void EmettreMessage (const std::string &Message);
void DecrireResultats ();
bool NbHerosValide ();

#include "Temps.h"

Temps<Milliseconde> RythmeAvatarNormal();
Temps<Milliseconde> RythmeAvatarRush();
Temps<Milliseconde> RythmeMonstreNormal();
Temps<Milliseconde> RythmeAffichage();

#endif