#ifndef SINGLETONSORDONNES_H
#define SINGLETONSORDONNES_H

#include "Incopiable.h"
#include "ConteneurSingleton.h"

template <class TList>
   class SingletonsOrdonnes
      : ConteneurSingleton<TList>, Incopiable
   {
      static SingletonsOrdonnes singleton;
      SingletonsOrdonnes () throw()
         { }
   public:
      ~SingletonsOrdonnes () throw()
         { }
      static SingletonsOrdonnes & Get () throw()
         { return singleton; }
      template <class T>
         T & GetSingleton () throw()
            { return ConteneurSingleton<TList>::Get<T> (); }
   };
//
// Cette globale peut rester dans le .h vu que le compilateur
// se charge d'viter la double instanciation des templates
//
template <class TList>
   SingletonsOrdonnes<TList> SingletonsOrdonnes<TList>::singleton;


#endif
