#ifndef TESTABLE_H
#define TESTABLE_H

class Testable
{
public:
   typedef void (Testable::*bool_type)() const;
   bool_type true_value () const
      { return &Testable::methodeIncomparable; }
   bool_type false_value () const
      { return 0; }
protected:
   void methodeIncomparable() const {}
public:
   Testable () { }
   operator bool_type() const
      { return testValidite (); }
   virtual ~Testable () {}
protected:
   virtual bool_type testValidite () const = 0;
};

template <typename T>
   bool operator==(const Testable &t, const T &o)
{
   t.methodeIncomparable(); return false;
}

template <typename T>
   bool operator!=(const Testable &t, const T &o)
{
   t.methodeIncomparable(); return false;
}

#endif